Index: ow/models/root.py
===================================================================
--- ow/models/root.py	(revision 5ec3a0b5cf5640304a0953320daef2a28bbca9a5)
+++ ow/models/root.py	(revision 39b14977ea6c9734e86296a94d7560ff9591a1c9)
@@ -62,10 +62,10 @@
         return [u for u in self.values() if isinstance(u, User)]
 
-    def get_user(self, user_id):
-        return self.get(user_id, None)
+    def get_user(self, uid):
+        return self.get(uid, None)
 
-    def add_user(self, user_id, **kw):
+    def add_user(self, uid, **kw):
         u = User(**kw)
-        self[user_id] = u
+        self[uid] = u
 
     @property
Index: ow/schemas/user.py
===================================================================
--- ow/schemas/user.py	(revision 5ec3a0b5cf5640304a0953320daef2a28bbca9a5)
+++ ow/schemas/user.py	(revision 39b14977ea6c9734e86296a94d7560ff9591a1c9)
@@ -51,5 +51,5 @@
     allow_extra_fields = True
     filter_extra_fields = True
-    user_id = validators.UnicodeString()
+    uid = validators.UnicodeString()
     firstname = validators.UnicodeString()
     lastname = validators.UnicodeString()
Index: ow/security.py
===================================================================
--- ow/security.py	(revision 5ec3a0b5cf5640304a0953320daef2a28bbca9a5)
+++ ow/security.py	(revision 39b14977ea6c9734e86296a94d7560ff9591a1c9)
@@ -1,5 +1,5 @@
 
 
-def groupfinder(user_id, request):
+def groupfinder(uid, request):
     """
     Return the groups a user belongs to.
@@ -9,5 +9,5 @@
     allow other users to view workouts from a given user
     """
-    if user_id in request.root.all_usernames():
-        return [user_id]
+    if uid in request.root.all_usernames():
+        return [uid]
     return []
Index: ow/templates/add_user.pt
===================================================================
--- ow/templates/add_user.pt	(revision 5ec3a0b5cf5640304a0953320daef2a28bbca9a5)
+++ ow/templates/add_user.pt	(revision 39b14977ea6c9734e86296a94d7560ff9591a1c9)
@@ -22,7 +22,7 @@
 
       <fieldset>
-        ${form.errorlist('user_id')}
+        ${form.errorlist('uid')}
         <label for="email" i18n:translate="">User ID:</label>
-        ${form.text('user_id')}
+        ${form.text('uid')}
         ${form.errorlist('email')}
         <label for="email" i18n:translate="">E-Mail:</label>
Index: ow/templates/profile.pt
===================================================================
--- ow/templates/profile.pt	(revision 5ec3a0b5cf5640304a0953320daef2a28bbca9a5)
+++ ow/templates/profile.pt	(revision 39b14977ea6c9734e86296a94d7560ff9591a1c9)
@@ -21,5 +21,5 @@
       <h2>
         <tal:fullname tal:content="context.fullname"></tal:fullname>
-        (<tal:user_id tal:content="context.user_id"></tal:user_id>)
+        (<tal:uid tal:content="context.uid"></tal:uid>)
       </h2>
       <h3>
Index: ow/templates/user_list.pt
===================================================================
--- ow/templates/user_list.pt	(revision 5ec3a0b5cf5640304a0953320daef2a28bbca9a5)
+++ ow/templates/user_list.pt	(revision 39b14977ea6c9734e86296a94d7560ff9591a1c9)
@@ -26,5 +26,5 @@
       </thead>
       <tal:r tal:repeat="user users">
-      <tr tal:attributes="id 'user-' + user.user_id">
+      <tr tal:attributes="id 'user-' + str(user.uid)">
         <td>${user.fullname}</td>
         <td>${user.email}</td>
Index: ow/tests/models/test_root.py
===================================================================
--- ow/tests/models/test_root.py	(revision 5ec3a0b5cf5640304a0953320daef2a28bbca9a5)
+++ ow/tests/models/test_root.py	(revision 39b14977ea6c9734e86296a94d7560ff9591a1c9)
@@ -30,5 +30,5 @@
 
     def test_lowercase_usernames(self, root):
-        root.add_user(user_id='Jack', firstname='Jack', lastname='Dumb',
+        root.add_user(uid='Jack', firstname='Jack', lastname='Dumb',
                       email='jack.dumb@example.net')
         assert root.lowercase_usernames() == ['jack', 'john']
@@ -38,5 +38,5 @@
 
     def test_lowercase_emails(self, root):
-        root.add_user(user_id='Jack', firstname='Jack', lastname='Dumb',
+        root.add_user(uid='Jack', firstname='Jack', lastname='Dumb',
                       email='Jack.Dumb@example.net')
         assert root.lowercase_emails() == ['jack.dumb@example.net',
@@ -55,5 +55,5 @@
     def test_add_user(self, root):
         assert len(root.users()) == 1
-        root.add_user(user_id='jack', firstname='Jack', lastname='Dumb',
+        root.add_user(uid='jack', firstname='Jack', lastname='Dumb',
                       email='jack.dumb@example.net')
         assert len(root.users()) == 2
Index: ow/tests/views/test_root.py
===================================================================
--- ow/tests/views/test_root.py	(revision 5ec3a0b5cf5640304a0953320daef2a28bbca9a5)
+++ ow/tests/views/test_root.py	(revision 39b14977ea6c9734e86296a94d7560ff9591a1c9)
@@ -73,5 +73,5 @@
     def test_add_user_post_valid(self, post_request):
         request = post_request
-        request.POST['user_id'] = 'addeduser'
+        request.POST['uid'] = 'addeduser'
         request.POST['email'] = 'addeduser@example.net'
         request.POST['firstname'] = 'added'
Index: ow/views/root.py
===================================================================
--- ow/views/root.py	(revision 5ec3a0b5cf5640304a0953320daef2a28bbca9a5)
+++ ow/views/root.py	(revision 39b14977ea6c9734e86296a94d7560ff9591a1c9)
@@ -34,7 +34,7 @@
 
     if 'submit' in request.POST and form.validate():
-        user_id = request.POST['user_id']
-        user = form.bind(User(), exclude=['user_id'])
-        context[user_id] = user
+        uid = request.POST['uid']
+        user = form.bind(User(), exclude=['uid'])
+        context[uid] = user
         return HTTPFound(location=request.resource_url(context, 'userlist'))
 